#include "WinMain.h"
#include "Board.h"

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// O[oϐ
HINSTANCE	g_hInstance;
bool		g_bCheckSound;
TCHAR		g_szName[128];

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// _CAÕbZ[W
BOOL CALLBACK DialogProc( HWND hWnd , UINT uMsg , WPARAM wParam , LPARAM lParam );

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// WindowsvÕGg[|Cg
int WINAPI WinMain( HINSTANCE hInstance , HINSTANCE hPrevInstance , LPSTR lpCmdLine , int nCmdShow )
{
	// CX^Xۑ
	g_hInstance = hInstance;

	// ݒݒ肷
	g_bCheckSound = true;
	ZeroMemory( g_szName , sizeof( g_szName ) );

	///////////// EBhENXo^ /////////////
	WNDCLASSEX wcl;
	ZeroMemory( &wcl , sizeof( wcl ) );
	wcl.cbSize			= sizeof( wcl );									// \̂̃TCYiɂAPIō\̂̃o[W𔻒fj
	wcl.lpszClassName	= APP_NAME;											// NX
	wcl.hInstance		= hInstance;										// CX^X
	wcl.hIcon			= LoadIcon( hInstance , (LPCWSTR)IDI_ICON1 );		// EBhẼACR
	wcl.hCursor			= LoadCursor( hInstance , (LPCWSTR)IDC_CURSOR1 );	// EBhẼJ[\
	wcl.hbrBackground	= (HBRUSH)GetStockObject( WHITE_BRUSH );			// wiF
	wcl.lpfnWndProc		= WndProc;											// R[obN֐̃|C^
	wcl.lpszMenuName	= (LPCWSTR)IDR_MENU1;

	if( !RegisterClassEx( &wcl ) )
		return 0;

	/////////// EBhE쐬 ///////////
	HWND hWnd;
	hWnd = CreateWindow(APP_NAME , APP_NAME , WS_OVERLAPPEDWINDOW ,
						CW_USEDEFAULT , CW_USEDEFAULT ,		// ftHg̈ʒuɂ
						WIN_WIDTH , WIN_HEIGHT ,
						NULL , NULL , hInstance , 0 );

	ShowWindow( hWnd , nCmdShow );
	UpdateWindow( hWnd );

	/////////// bZ[W[v ///////////
	MSG msg;
	while( 0 != GetMessage( &msg , NULL , 0 , 0 ) )
	{
		TranslateMessage( &msg );
		DispatchMessage( &msg );
	}
	return msg.wParam;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// WindowsbZ[W󂯎R[obN֐
LRESULT CALLBACK WndProc( HWND hWnd , UINT uMsg , WPARAM wParam , LPARAM lParam )
{
	switch( uMsg )
	{
	case WM_COMMAND:
		// j[
		switch( LOWORD( wParam ) )
		{
		case ID_MENU_EXIT:		// uI(&X)v
			// AvP[VI
			PostQuitMessage( 0 );
			break;
		case ID_MENU_OPTION:	// uIvV(&O)v
			{
				// _CAO\
				int nResult = DialogBox( g_hInstance , (LPCWSTR)IDD_DIALOG1 , hWnd , DialogProc );

				if( nResult == 1 )
				{	// OK{^ꂽ

					// ݂̐ݒ\
					TCHAR szMessage[1024];
					ZeroMemory( szMessage , sizeof( szMessage ) );
					lstrcat( szMessage , TEXT( "ݒ肳܂B\n" ) );
					lstrcat( szMessage , TEXT( "OG" ) );
					lstrcat( szMessage , g_szName );
					lstrcat( szMessage , TEXT( "\n" ) );
					if( g_bCheckSound )	lstrcat( szMessage , TEXT( "TEhĐFON" ) );
					else				lstrcat( szMessage , TEXT( "TEhĐFOFF" ) );

					MessageBox( hWnd , szMessage , TEXT( "ݒ芮" ) , MB_OK | MB_ICONINFORMATION );
				}
			}
			return 1;
		}
		break;

	case WM_LBUTTONDOWN:
		// BoardNXɏۓ
		g_Board.OnLButtonDown( hWnd , LOWORD( lParam ) , HIWORD( lParam ) );
		return 1;

	case WM_RBUTTONDOWN:
		// BoardNXɏۓ
		g_Board.OnRButtonDown( hWnd , LOWORD( lParam ) , HIWORD( lParam ) );
		return 1;

	case WM_PAINT:
		// BoardNXɏۓ
		g_Board.OnPaint( hWnd );
		return 1;

	case WM_DESTROY:
		PostQuitMessage( 0 );
		break;

	default:
		return DefWindowProc( hWnd , uMsg , wParam , lParam );
	}
	return 0;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// _CAÕbZ[W
BOOL CALLBACK DialogProc( HWND hWnd , UINT uMsg , WPARAM wParam , LPARAM lParam )
{
	switch( uMsg )
	{
	case WM_INITDIALOG:
		{
			// _CAO쐬ƂɌĂ΂郁bZ[W

			// _CAOACẽnh擾
			HWND hEdit	= GetDlgItem( hWnd , IDC_EDIT1 );
			HWND hCheck	= GetDlgItem( hWnd , IDC_CHECK1 );

			// GfBbg{bNXɃeLXgݒ肷
			SetWindowText( hEdit , g_szName );

			// `FbN{bNXݒ肷
			if( g_bCheckSound )
				SendMessage( hCheck , BM_SETCHECK , (WPARAM)BST_CHECKED , 0 );
			else
				SendMessage( hCheck , BM_SETCHECK , (WPARAM)BST_UNCHECKED , 0 );
		}
		return TRUE;

	case WM_COMMAND:
		switch( LOWORD( wParam ) )
		{
		case IDOK:
			{
				// uOKv{^ꂽ

				// _CAOACẽnh擾
				HWND hEdit	= GetDlgItem( hWnd , IDC_EDIT1 );
				HWND hCheck	= GetDlgItem( hWnd , IDC_CHECK1 );

				// GfBbg{bNXeLXg擾
				GetWindowText( hEdit , g_szName , sizeof( g_szName ) );

				// `FbN{bNX擾
				if( BST_CHECKED == SendMessage( hCheck , BM_GETCHECK , 0 , 0 ) )
					g_bCheckSound = true;
				else
					g_bCheckSound = false;

				// _CAOI
				EndDialog( hWnd , 1 );
			}
			// ̂TRUEԂ
			return TRUE;	
		case IDCANCEL:
			{
				// uLZv{^ꂽ

				// _CAOI
				EndDialog( hWnd , 0 );
			}
			// ̂TRUEԂ
			return TRUE;
		}
		break;
	}
	// Ȃ̂FALSEԂ
	return FALSE;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
